#!/bin/sh

if [ $# -eq 1 ]; then
if [ -d $1 ]; then
if [ -e $1/tomcat/webapps/aipo/WEB-INF/conf/AipoResources.properties ]; then
parent_dir=$1



#######################################################################
#
#######################################################################
. /etc/sysconfig/network-scripts/ifcfg-eth0
addr=$IPADDR
if [ "$addr" = "" ]; then
	addr=`ifconfig eth0 | grep "inet addr" | cut -f 2 -d :| cut -f 1 -d " "`
fi

#############################################
## ɬפѿ򥻥å
#############################################
#AipoС
aipo_version="5.0.1.0"
aipo_version_int="5010"
# 롼ײ
Max_Loop="100"

#桼ǧ
current_user=`whoami`
if [ "${current_user}" != "root" ]; then
    echo "Aipo$aipo_versionΥ󥹥ȡroot¤ǹԤäƤ"
    exit 0
fi

#Old Version
tmp_str=`cat ${parent_dir}/tomcat/webapps/aipo/WEB-INF/conf/AipoResources.properties | grep aipo.version=`
old_version=`echo "$tmp_str" | cut -f 2 -d "="`
isCR=`expr match $old_version .*[0-9]$ `
if [ "$isCR" = "0" ]; then
    len=`expr length $old_version`
    len=`expr $len - 1`
    old_version=`expr substr $old_version 1 $len`
fi
echo $old_version

#Хååץե
mkdir -p ${script_path}/backup
bk_dir=${script_path}/backup

#######################################################################
#
#######################################################################
function restorefunc
{
    alias cp='cp'
    if [ -d $bk_dir/tomcat/ ]; then
       if [ -e $parent_dir/tomcat/webapps ]; then
            mv $parent_dir/tomcat/webapps $parent_dir/tomcat/webappsbk${date_str}
       fi
       cp -rf  $bk_dir/tomcat/webapps $parent_dir/tomcat/
    fi

    sudo -u $postgres_user $parent_dir/postgres/bin/pg_ctl -D $parent_dir/postgres/data -o "-S -i" stop

    echo "Aipo$aipo_versionؤΥåץǡȤ˼Ԥޤ"
    alias cp='cp -i'
    exit 1
}

function restoreDBfunc
{
    echo "ǡ١򳫻Ϥޤ"
    #org001͡षorg001failed
    sudo -u $postgres_user $parent_dir/postgres/bin/psql org001bk${date_str} -c "ALTER DATABASE org001 RENAME TO org001failed${date_str};"
    #org001bk${date_str}򥳥ԡorg001
    sudo -u $postgres_user $parent_dir/postgres/bin/psql org001bk${date_str} -c "CREATE DATABASE org001 TEMPLATE org001bk${date_str};"
    if [ $? != 0 ]; then
       echo "ǡ١˼Ԥޤ"
       restorefunc
    fi
    echo "ǡ١λޤ"
    restorefunc
}

#AipoСǧ
if [ "$old_version" = "$aipo_version" ]; then
	echo "Aipo$aipo_version󥹥ȡ뤵Ƥޤ"
	exit 0
fi

if [ "${old_version}" != "4.0.5.0" ]; then
	echo "Aipo$old_versionбƤޤ"
	exit 0
fi

tmp_str=`cat $parent_dir/bin/startup.sh | grep "s_port_num="`
s_port_num=`echo "$tmp_str" | cut -f 2 -d "="`

#ΥСPostgreSQL桼
echo "PostgreSQLΥ桼Ƥޤ"
tmp_str=`cat $parent_dir/tomcat/webapps/aipo/WEB-INF/conf/postgres/Org001DomainNode.driver.xml | grep login`
postgres_user=`echo "$tmp_str" | cut -f 2 -d " " | cut -f 2 -d = | cut -f 2 -d \"`
echo user:$postgres_user
pass=`echo "$tmp_str" | cut -f 3 -d " " | cut -f 2 -d = | cut -f 1 -d \\/ | cut -f 2 -d \"`
echo passwd:$pass

tmp_str=`cat $parent_dir/tomcat/webapps/aipo/WEB-INF/conf/postgres/Org001DomainNode.driver.xml | grep url`
port_num=`echo "$tmp_str" | cut -f 4 -d ":" | cut -f 1 -d \\/ `
echo port:$port_num

unset tmp_str

sh $parent_dir/bin/shutdown.sh

#PostgreSQLεư
sudo -u $postgres_user $parent_dir/postgres/bin/postmaster -D $parent_dir/postgres/data -S -i
#wait
prc_name="$parent_dir/postgres/bin/postmaster"
count=0
while [ $count -lt $Max_Loop ]; do
	tmp_str=`ps auxww | grep $prc_name`
	tmp_str=`echo $tmp_str`
	pid_str=`echo "$tmp_str" | cut -f 2 -d " "`
	tmp_str=`netstat -nap | grep "ESTABLISHED $pid_str"`
	if [ "$tmp_str" != "" ]; then
		echo $tmp_str
		break
	fi
	count=`expr $count + 1`
done



#################################################
##եΥԡ
#################################################

#Хåå
mkdir -p $bk_dir/tomcat/
cp -rf $parent_dir/tomcat/webapps $bk_dir/tomcat/
#ǡ١Υԡ
date_str=`date +"%Y%m%d%H%M"`
sudo -u $postgres_user $parent_dir/postgres/bin/psql org001 -c "CREATE DATABASE org001bk${date_str} TEMPLATE org001;"
#pgpassι
sudo -u ${postgres_user} echo "localhost:$port_num:org001bk${date_str}:${postgres_user}:$pass" >> /home/${postgres_user}/.pgpass
chown ${postgres_user}:${postgres_user} /home/${postgres_user}/.pgpass
sudo -u ${postgres_user} chmod 0600 /home/${postgres_user}/.pgpass

#ԡ
alias cp='cp'
tmp_version=$old_version

if [ "$tmp_version" = "4.0.5.0" ]; then
    echo "Update from Aipo 4.0.5.0 ..."
    cp -rf ${script_path}/aipo5010/dpl003/tomcat/webapps $parent_dir/tomcat/
    cp -rf ${script_path}/aipo5010/dpl003/tomcat/webapps/aipo/WEB-INF/conf/*.xreg ${parent_dir}/backup/xreg

    #UPDATE DATA BASE By PSQL
    cd ${script_path}/aipo5010/bin
    sudo -u $postgres_user ${parent_dir}/postgres/bin/psql org001 -f aipo5010update.sql

    if [ $? != 0 ]; then
       restorefunc
    fi

    #ơ֥빽¤
    echo "ơ֥빽¤θڤ򳫻Ϥޤ"
    sudo -u $postgres_user ${parent_dir}/postgres/bin/psql org001 -f ${script_path}/aipo_common/bin/select_tables.sql > ${script_path}/check_table.txt

    if [ $? != 0 ] || [ ! -e ${script_path}/check_table.txt ]; then
        echo "ơ֥빽¤θڤ˼Ԥޤ"
        restoreDBfunc
    fi

    diff_result=`diff -w table_dump5010 ${script_path}/check_table.txt`
    if [ "$diff_result" != "" ]; then
        echo "ǡ١ι˼Ԥǽޤ"
        restoreDBfunc
    fi
    echo "ơ֥빽¤θڤλޤ"
    rm ${script_path}/check_table.txt

    # UPDATE PSML
    cd ${script_path}/aipo5010/bin
    ${parent_dir}/jre/bin/java -cp "." com.aimluck.eip.update.UpdatePsml4050to5010 ${parent_dir}/tomcat/webapps ""
    if [ $? != 0 ]; then
        restorefunc
    fi
    tmp_version="5.0.1.0"
fi

# Update Template
# if [ "$tmp_version" = "4.x.x.x" ]; then
#
#    echo "Update from Aipo 4.x.x.x ..."
#    cp -rf ${script_path}/aipoyyyy/dpl003/tomcat/webapps ${parent_dir}/tomcat/
#    cp -rf ${script_path}/aipoyyyy/dpl003/license ${parent_dir}
#    cp -rf ${script_path}/aipoyyyy/dpl003/tomcat/webapps/aipo/WEB-INF/conf/*.xreg ${parent_dir}/backup/xreg
#    cp -rf ${script_path}/aipoyyy/dpl003/src/bin ${parent_dir}/backup/xreg
#
#    #UPDATE DATA BASE By PSQL
#    cd ${script_path}/aipoyyyy/bin
#    sudo -u $postgres_user ${parent_dir}/postgres/bin/psql org001 -f aipo4yyyyupdate.sql
#   tmp_version="4.y.y.y"
# fi

if [ $tmp_version != $aipo_version ]; then
    restorefunc
fi

cp -rf ${script_path}/aipo${aipo_version_int}/dpl003/license/license.txt ${parent_dir}
alias cp='cp -i'

############################################
#¹ѥץ
############################################

echo "${parent_dir}" | sed s/'\/'/'\\\/'/g > temp.txt
tmp_str=`cat temp.txt`
rm -rf temp.txt
echo $tmp_str

mkdir -p $bk_dir/bin
cp -rf ${parent_dir}/bin/*.sh $bk_dir/bin/

cd ${script_path}/aipo${aipo_version_int}/dpl003/src/bin/${enc_str}
for FILE in *.sh; do
	mv -f ${parent_dir}/bin/$FILE $bk_dir/bin/$FILE
	sed "s/default_folder/$tmp_str/g" ${script_path}/aipo${aipo_version_int}/dpl003/src/bin/${enc_str}/$FILE | sed "s/default_user/$postgres_user/g" | sed "s/default_server_port/$s_port_num/g" | sed "s/default_db_port/$port_num/g" | sed "s/postgres_pass/$pass/g" | sed "s/Aipo_Version/$aipo_version/g" > ${parent_dir}/bin/$FILE
done

chmod +x ${parent_dir}/bin/*.sh

###################################################
##λ
###################################################
sudo -u $postgres_user ${parent_dir}/postgres/bin/pg_ctl -D ${parent_dir}/postgres/data -o "-S -i" stop
#wait

######################################
#ɽ
######################################
echo ==Aipo"$aipo_version"åץǡȽλ==
echo user:$postgres_user
echo pass:$pass
echo directory:${parent_dir}
echo port:$port_num
echo "Aipo URL: http://$addr:$s_port_num/aipo/"

else
 echo "The input directory is wrong."
fi

else
 echo "No folder."
fi

else
 echo "Please input the directory of aipo."
fi